/**
 * @name array-of-arrays-into-ast
 * @fileoverview Turns an array of arrays of data into a nested tree of plain objects
 * @version 4.0.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/array-of-arrays-into-ast/}
 */

"use strict";var arrayOfArraysIntoAst=(()=>{var fr=Object.create;var R=Object.defineProperty,ur=Object.defineProperties,pr=Object.getOwnPropertyDescriptor,yr=Object.getOwnPropertyDescriptors,lr=Object.getOwnPropertyNames,Rt=Object.getOwnPropertySymbols,hr=Object.getPrototypeOf,Gt=Object.prototype.hasOwnProperty,gr=Object.prototype.propertyIsEnumerable;var Ht=(t,e,r)=>e in t?R(t,e,{enumerable:!0,configurable:!0,writable:!0,value:r}):t[e]=r,_=(t,e)=>{for(var r in e||(e={}))Gt.call(e,r)&&Ht(t,r,e[r]);if(Rt)for(var r of Rt(e))gr.call(e,r)&&Ht(t,r,e[r]);return t},W=(t,e)=>ur(t,yr(e));var I=(t,e)=>()=>(e||t((e={exports:{}}).exports,e),e.exports),dr=(t,e)=>{for(var r in e)R(t,r,{get:e[r],enumerable:!0})},Bt=(t,e,r,n)=>{if(e&&typeof e=="object"||typeof e=="function")for(let a of lr(e))!Gt.call(t,a)&&a!==r&&R(t,a,{get:()=>e[a],enumerable:!(n=pr(e,a))||n.enumerable});return t};var w=(t,e,r)=>(r=t!=null?fr(hr(t)):{},Bt(e||!t||!t.__esModule?R(r,"default",{value:t,enumerable:!0}):r,t)),br=t=>Bt(R({},"__esModule",{value:!0}),t);var Ce=I((H,M)=>{var _r=200,te="__lodash_hash_undefined__",ee=9007199254740991,ht="[object Arguments]",mr="[object Array]",re="[object Boolean]",ne="[object Date]",Or="[object Error]",gt="[object Function]",oe="[object GeneratorFunction]",J="[object Map]",ie="[object Number]",dt="[object Object]",Lt="[object Promise]",ae="[object RegExp]",q="[object Set]",se="[object String]",ce="[object Symbol]",ct="[object WeakMap]",fe="[object ArrayBuffer]",Y="[object DataView]",ue="[object Float32Array]",pe="[object Float64Array]",ye="[object Int8Array]",le="[object Int16Array]",he="[object Int32Array]",ge="[object Uint8Array]",de="[object Uint8ClampedArray]",be="[object Uint16Array]",_e="[object Uint32Array]",jr=/[\\^$.*+?()[\]{}|]/g,vr=/\w*$/,xr=/^\[object .+?Constructor\]$/,Ar=/^(?:0|[1-9]\d*)$/,l={};l[ht]=l[mr]=l[fe]=l[Y]=l[re]=l[ne]=l[ue]=l[pe]=l[ye]=l[le]=l[he]=l[J]=l[ie]=l[dt]=l[ae]=l[q]=l[se]=l[ce]=l[ge]=l[de]=l[be]=l[_e]=!0;l[Or]=l[gt]=l[ct]=!1;var Sr=typeof global=="object"&&global&&global.Object===Object&&global,wr=typeof self=="object"&&self&&self.Object===Object&&self,j=Sr||wr||Function("return this")(),me=typeof H=="object"&&H&&!H.nodeType&&H,Vt=me&&typeof M=="object"&&M&&!M.nodeType&&M,kr=Vt&&Vt.exports===me;function Tr(t,e){return t.set(e[0],e[1]),t}function Er(t,e){return t.add(e),t}function Cr(t,e){for(var r=-1,n=t?t.length:0;++r<n&&e(t[r],r,t)!==!1;);return t}function Ir(t,e){for(var r=-1,n=e.length,a=t.length;++r<n;)t[a+r]=e[r];return t}function Oe(t,e,r,n){var a=-1,o=t?t.length:0;for(n&&o&&(r=t[++a]);++a<o;)r=e(r,t[a],a,t);return r}function Mr(t,e){for(var r=-1,n=Array(t);++r<t;)n[r]=e(r);return n}function $r(t,e){return t==null?void 0:t[e]}function je(t){var e=!1;if(t!=null&&typeof t.toString!="function")try{e=!!(t+"")}catch(r){}return e}function Ut(t){var e=-1,r=Array(t.size);return t.forEach(function(n,a){r[++e]=[a,n]}),r}function bt(t,e){return function(r){return t(e(r))}}function Wt(t){var e=-1,r=Array(t.size);return t.forEach(function(n){r[++e]=n}),r}var Pr=Array.prototype,Fr=Function.prototype,X=Object.prototype,st=j["__core-js_shared__"],Jt=function(){var t=/[^.]+$/.exec(st&&st.keys&&st.keys.IE_PROTO||"");return t?"Symbol(src)_1."+t:""}(),ve=Fr.toString,x=X.hasOwnProperty,Z=X.toString,Nr=RegExp("^"+ve.call(x).replace(jr,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),qt=kr?j.Buffer:void 0,Yt=j.Symbol,Xt=j.Uint8Array,Kr=bt(Object.getPrototypeOf,Object),Dr=Object.create,Rr=X.propertyIsEnumerable,Hr=Pr.splice,Zt=Object.getOwnPropertySymbols,Gr=qt?qt.isBuffer:void 0,Br=bt(Object.keys,Object),ft=F(j,"DataView"),G=F(j,"Map"),ut=F(j,"Promise"),pt=F(j,"Set"),yt=F(j,"WeakMap"),B=F(Object,"create"),Lr=E(ft),Vr=E(G),Ur=E(ut),Wr=E(pt),Jr=E(yt),zt=Yt?Yt.prototype:void 0,Qt=zt?zt.valueOf:void 0;function T(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var n=t[e];this.set(n[0],n[1])}}function qr(){this.__data__=B?B(null):{}}function Yr(t){return this.has(t)&&delete this.__data__[t]}function Xr(t){var e=this.__data__;if(B){var r=e[t];return r===te?void 0:r}return x.call(e,t)?e[t]:void 0}function Zr(t){var e=this.__data__;return B?e[t]!==void 0:x.call(e,t)}function zr(t,e){var r=this.__data__;return r[t]=B&&e===void 0?te:e,this}T.prototype.clear=qr;T.prototype.delete=Yr;T.prototype.get=Xr;T.prototype.has=Zr;T.prototype.set=zr;function v(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var n=t[e];this.set(n[0],n[1])}}function Qr(){this.__data__=[]}function tn(t){var e=this.__data__,r=z(e,t);if(r<0)return!1;var n=e.length-1;return r==n?e.pop():Hr.call(e,r,1),!0}function en(t){var e=this.__data__,r=z(e,t);return r<0?void 0:e[r][1]}function rn(t){return z(this.__data__,t)>-1}function nn(t,e){var r=this.__data__,n=z(r,t);return n<0?r.push([t,e]):r[n][1]=e,this}v.prototype.clear=Qr;v.prototype.delete=tn;v.prototype.get=en;v.prototype.has=rn;v.prototype.set=nn;function $(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var n=t[e];this.set(n[0],n[1])}}function on(){this.__data__={hash:new T,map:new(G||v),string:new T}}function an(t){return Q(this,t).delete(t)}function sn(t){return Q(this,t).get(t)}function cn(t){return Q(this,t).has(t)}function fn(t,e){return Q(this,t).set(t,e),this}$.prototype.clear=on;$.prototype.delete=an;$.prototype.get=sn;$.prototype.has=cn;$.prototype.set=fn;function P(t){this.__data__=new v(t)}function un(){this.__data__=new v}function pn(t){return this.__data__.delete(t)}function yn(t){return this.__data__.get(t)}function ln(t){return this.__data__.has(t)}function hn(t,e){var r=this.__data__;if(r instanceof v){var n=r.__data__;if(!G||n.length<_r-1)return n.push([t,e]),this;r=this.__data__=new $(n)}return r.set(t,e),this}P.prototype.clear=un;P.prototype.delete=pn;P.prototype.get=yn;P.prototype.has=ln;P.prototype.set=hn;function gn(t,e){var r=mt(t)||Rn(t)?Mr(t.length,String):[],n=r.length,a=!!n;for(var o in t)(e||x.call(t,o))&&!(a&&(o=="length"||Fn(o,n)))&&r.push(o);return r}function xe(t,e,r){var n=t[e];(!(x.call(t,e)&&ke(n,r))||r===void 0&&!(e in t))&&(t[e]=r)}function z(t,e){for(var r=t.length;r--;)if(ke(t[r][0],e))return r;return-1}function dn(t,e){return t&&Ae(e,Ot(e),t)}function lt(t,e,r,n,a,o,i){var f;if(n&&(f=o?n(t,a,o,i):n(t)),f!==void 0)return f;if(!tt(t))return t;var p=mt(t);if(p){if(f=Mn(t),!e)return En(t,f)}else{var g=k(t),d=g==gt||g==oe;if(Gn(t))return vn(t,e);if(g==dt||g==ht||d&&!o){if(je(t))return o?t:{};if(f=$n(d?{}:t),!e)return Cn(t,dn(f,t))}else{if(!l[g])return o?t:{};f=Pn(t,g,lt,e)}}i||(i=new P);var u=i.get(t);if(u)return u;if(i.set(t,f),!p)var s=r?In(t):Ot(t);return Cr(s||t,function(h,y){s&&(y=h,h=t[y]),xe(f,y,lt(h,e,r,n,y,t,i))}),f}function bn(t){return tt(t)?Dr(t):{}}function _n(t,e,r){var n=e(t);return mt(t)?n:Ir(n,r(t))}function mn(t){return Z.call(t)}function On(t){if(!tt(t)||Kn(t))return!1;var e=Ee(t)||je(t)?Nr:xr;return e.test(E(t))}function jn(t){if(!we(t))return Br(t);var e=[];for(var r in Object(t))x.call(t,r)&&r!="constructor"&&e.push(r);return e}function vn(t,e){if(e)return t.slice();var r=new t.constructor(t.length);return t.copy(r),r}function _t(t){var e=new t.constructor(t.byteLength);return new Xt(e).set(new Xt(t)),e}function xn(t,e){var r=e?_t(t.buffer):t.buffer;return new t.constructor(r,t.byteOffset,t.byteLength)}function An(t,e,r){var n=e?r(Ut(t),!0):Ut(t);return Oe(n,Tr,new t.constructor)}function Sn(t){var e=new t.constructor(t.source,vr.exec(t));return e.lastIndex=t.lastIndex,e}function wn(t,e,r){var n=e?r(Wt(t),!0):Wt(t);return Oe(n,Er,new t.constructor)}function kn(t){return Qt?Object(Qt.call(t)):{}}function Tn(t,e){var r=e?_t(t.buffer):t.buffer;return new t.constructor(r,t.byteOffset,t.length)}function En(t,e){var r=-1,n=t.length;for(e||(e=Array(n));++r<n;)e[r]=t[r];return e}function Ae(t,e,r,n){r||(r={});for(var a=-1,o=e.length;++a<o;){var i=e[a],f=n?n(r[i],t[i],i,r,t):void 0;xe(r,i,f===void 0?t[i]:f)}return r}function Cn(t,e){return Ae(t,Se(t),e)}function In(t){return _n(t,Ot,Se)}function Q(t,e){var r=t.__data__;return Nn(e)?r[typeof e=="string"?"string":"hash"]:r.map}function F(t,e){var r=$r(t,e);return On(r)?r:void 0}var Se=Zt?bt(Zt,Object):Vn,k=mn;(ft&&k(new ft(new ArrayBuffer(1)))!=Y||G&&k(new G)!=J||ut&&k(ut.resolve())!=Lt||pt&&k(new pt)!=q||yt&&k(new yt)!=ct)&&(k=function(t){var e=Z.call(t),r=e==dt?t.constructor:void 0,n=r?E(r):void 0;if(n)switch(n){case Lr:return Y;case Vr:return J;case Ur:return Lt;case Wr:return q;case Jr:return ct}return e});function Mn(t){var e=t.length,r=t.constructor(e);return e&&typeof t[0]=="string"&&x.call(t,"index")&&(r.index=t.index,r.input=t.input),r}function $n(t){return typeof t.constructor=="function"&&!we(t)?bn(Kr(t)):{}}function Pn(t,e,r,n){var a=t.constructor;switch(e){case fe:return _t(t);case re:case ne:return new a(+t);case Y:return xn(t,n);case ue:case pe:case ye:case le:case he:case ge:case de:case be:case _e:return Tn(t,n);case J:return An(t,n,r);case ie:case se:return new a(t);case ae:return Sn(t);case q:return wn(t,n,r);case ce:return kn(t)}}function Fn(t,e){return e=e==null?ee:e,!!e&&(typeof t=="number"||Ar.test(t))&&t>-1&&t%1==0&&t<e}function Nn(t){var e=typeof t;return e=="string"||e=="number"||e=="symbol"||e=="boolean"?t!=="__proto__":t===null}function Kn(t){return!!Jt&&Jt in t}function we(t){var e=t&&t.constructor,r=typeof e=="function"&&e.prototype||X;return t===r}function E(t){if(t!=null){try{return ve.call(t)}catch(e){}try{return t+""}catch(e){}}return""}function Dn(t){return lt(t,!0,!0)}function ke(t,e){return t===e||t!==t&&e!==e}function Rn(t){return Hn(t)&&x.call(t,"callee")&&(!Rr.call(t,"callee")||Z.call(t)==ht)}var mt=Array.isArray;function Te(t){return t!=null&&Bn(t.length)&&!Ee(t)}function Hn(t){return Ln(t)&&Te(t)}var Gn=Gr||Un;function Ee(t){var e=tt(t)?Z.call(t):"";return e==gt||e==oe}function Bn(t){return typeof t=="number"&&t>-1&&t%1==0&&t<=ee}function tt(t){var e=typeof t;return!!t&&(e=="object"||e=="function")}function Ln(t){return!!t&&typeof t=="object"}function Ot(t){return Te(t)?gn(t):jn(t)}function Vn(){return[]}function Un(){return!1}M.exports=Dn});var Ne=I((ca,Fe)=>{var Ie=1/0,$e=9007199254740991,Wn=17976931348623157e292,Me=0/0,Jn="[object Arguments]",qn="[object Function]",Yn="[object GeneratorFunction]",Xn="[object String]",Zn="[object Symbol]",zn=/^\s+|\s+$/g,Qn=/^[-+]0x[0-9a-f]+$/i,to=/^0b[01]+$/i,eo=/^0o[0-7]+$/i,ro=/^(?:0|[1-9]\d*)$/,no=parseInt;function oo(t,e){for(var r=-1,n=t?t.length:0,a=Array(n);++r<n;)a[r]=e(t[r],r,t);return a}function io(t,e,r,n){for(var a=t.length,o=r+(n?1:-1);n?o--:++o<a;)if(e(t[o],o,t))return o;return-1}function ao(t,e,r){if(e!==e)return io(t,so,r);for(var n=r-1,a=t.length;++n<a;)if(t[n]===e)return n;return-1}function so(t){return t!==t}function co(t,e){for(var r=-1,n=Array(t);++r<t;)n[r]=e(r);return n}function fo(t,e){return oo(e,function(r){return t[r]})}function uo(t,e){return function(r){return t(e(r))}}var et=Object.prototype,vt=et.hasOwnProperty,rt=et.toString,po=et.propertyIsEnumerable,yo=uo(Object.keys,Object),lo=Math.max;function ho(t,e){var r=Pe(t)||Oo(t)?co(t.length,String):[],n=r.length,a=!!n;for(var o in t)(e||vt.call(t,o))&&!(a&&(o=="length"||bo(o,n)))&&r.push(o);return r}function go(t){if(!_o(t))return yo(t);var e=[];for(var r in Object(t))vt.call(t,r)&&r!="constructor"&&e.push(r);return e}function bo(t,e){return e=e==null?$e:e,!!e&&(typeof t=="number"||ro.test(t))&&t>-1&&t%1==0&&t<e}function _o(t){var e=t&&t.constructor,r=typeof e=="function"&&e.prototype||et;return t===r}function mo(t,e,r,n){t=xt(t)?t:Co(t),r=r&&!n?ko(r):0;var a=t.length;return r<0&&(r=lo(a+r,0)),Ao(t)?r<=a&&t.indexOf(e,r)>-1:!!a&&ao(t,e,r)>-1}function Oo(t){return jo(t)&&vt.call(t,"callee")&&(!po.call(t,"callee")||rt.call(t)==Jn)}var Pe=Array.isArray;function xt(t){return t!=null&&xo(t.length)&&!vo(t)}function jo(t){return At(t)&&xt(t)}function vo(t){var e=jt(t)?rt.call(t):"";return e==qn||e==Yn}function xo(t){return typeof t=="number"&&t>-1&&t%1==0&&t<=$e}function jt(t){var e=typeof t;return!!t&&(e=="object"||e=="function")}function At(t){return!!t&&typeof t=="object"}function Ao(t){return typeof t=="string"||!Pe(t)&&At(t)&&rt.call(t)==Xn}function So(t){return typeof t=="symbol"||At(t)&&rt.call(t)==Zn}function wo(t){if(!t)return t===0?t:0;if(t=To(t),t===Ie||t===-Ie){var e=t<0?-1:1;return e*Wn}return t===t?t:0}function ko(t){var e=wo(t),r=e%1;return e===e?r?e-r:e:0}function To(t){if(typeof t=="number")return t;if(So(t))return Me;if(jt(t)){var e=typeof t.valueOf=="function"?t.valueOf():t;t=jt(e)?e+"":e}if(typeof t!="string")return t===0?t:+t;t=t.replace(zn,"");var r=to.test(t);return r||eo.test(t)?no(t.slice(2),r?2:8):Qn.test(t)?Me:+t}function Eo(t){return xt(t)?ho(t):go(t)}function Co(t){return t?fo(t,Eo(t)):[]}Fe.exports=mo});var Le=I((fa,Be)=>{var Io=200,kt="__lodash_hash_undefined__",Mo=1/0,$o="[object Function]",Po="[object GeneratorFunction]",Fo=/[\\^$.*+?()[\]{}|]/g,No=/^\[object .+?Constructor\]$/,Ko=typeof global=="object"&&global&&global.Object===Object&&global,Do=typeof self=="object"&&self&&self.Object===Object&&self,Tt=Ko||Do||Function("return this")();function Ro(t,e){var r=t?t.length:0;return!!r&&Bo(t,e,0)>-1}function Ho(t,e,r){for(var n=-1,a=t?t.length:0;++n<a;)if(r(e,t[n]))return!0;return!1}function Go(t,e,r,n){for(var a=t.length,o=r+(n?1:-1);n?o--:++o<a;)if(e(t[o],o,t))return o;return-1}function Bo(t,e,r){if(e!==e)return Go(t,Lo,r);for(var n=r-1,a=t.length;++n<a;)if(t[n]===e)return n;return-1}function Lo(t){return t!==t}function Vo(t,e){return t.has(e)}function Uo(t,e){return t==null?void 0:t[e]}function Wo(t){var e=!1;if(t!=null&&typeof t.toString!="function")try{e=!!(t+"")}catch(r){}return e}function De(t){var e=-1,r=Array(t.size);return t.forEach(function(n){r[++e]=n}),r}var Jo=Array.prototype,qo=Function.prototype,Re=Object.prototype,St=Tt["__core-js_shared__"],Ke=function(){var t=/[^.]+$/.exec(St&&St.keys&&St.keys.IE_PROTO||"");return t?"Symbol(src)_1."+t:""}(),He=qo.toString,Et=Re.hasOwnProperty,Yo=Re.toString,Xo=RegExp("^"+He.call(Et).replace(Fo,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),Zo=Jo.splice,zo=Ct(Tt,"Map"),wt=Ct(Tt,"Set"),L=Ct(Object,"create");function C(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var n=t[e];this.set(n[0],n[1])}}function Qo(){this.__data__=L?L(null):{}}function ti(t){return this.has(t)&&delete this.__data__[t]}function ei(t){var e=this.__data__;if(L){var r=e[t];return r===kt?void 0:r}return Et.call(e,t)?e[t]:void 0}function ri(t){var e=this.__data__;return L?e[t]!==void 0:Et.call(e,t)}function ni(t,e){var r=this.__data__;return r[t]=L&&e===void 0?kt:e,this}C.prototype.clear=Qo;C.prototype.delete=ti;C.prototype.get=ei;C.prototype.has=ri;C.prototype.set=ni;function N(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var n=t[e];this.set(n[0],n[1])}}function oi(){this.__data__=[]}function ii(t){var e=this.__data__,r=ot(e,t);if(r<0)return!1;var n=e.length-1;return r==n?e.pop():Zo.call(e,r,1),!0}function ai(t){var e=this.__data__,r=ot(e,t);return r<0?void 0:e[r][1]}function si(t){return ot(this.__data__,t)>-1}function ci(t,e){var r=this.__data__,n=ot(r,t);return n<0?r.push([t,e]):r[n][1]=e,this}N.prototype.clear=oi;N.prototype.delete=ii;N.prototype.get=ai;N.prototype.has=si;N.prototype.set=ci;function K(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var n=t[e];this.set(n[0],n[1])}}function fi(){this.__data__={hash:new C,map:new(zo||N),string:new C}}function ui(t){return it(this,t).delete(t)}function pi(t){return it(this,t).get(t)}function yi(t){return it(this,t).has(t)}function li(t,e){return it(this,t).set(t,e),this}K.prototype.clear=fi;K.prototype.delete=ui;K.prototype.get=pi;K.prototype.has=yi;K.prototype.set=li;function nt(t){var e=-1,r=t?t.length:0;for(this.__data__=new K;++e<r;)this.add(t[e])}function hi(t){return this.__data__.set(t,kt),this}function gi(t){return this.__data__.has(t)}nt.prototype.add=nt.prototype.push=hi;nt.prototype.has=gi;function ot(t,e){for(var r=t.length;r--;)if(xi(t[r][0],e))return r;return-1}function di(t){if(!Ge(t)||Oi(t))return!1;var e=Ai(t)||Wo(t)?Xo:No;return e.test(ji(t))}function bi(t,e,r){var n=-1,a=Ro,o=t.length,i=!0,f=[],p=f;if(r)i=!1,a=Ho;else if(o>=Io){var g=e?null:_i(t);if(g)return De(g);i=!1,a=Vo,p=new nt}else p=e?[]:f;t:for(;++n<o;){var d=t[n],u=e?e(d):d;if(d=r||d!==0?d:0,i&&u===u){for(var s=p.length;s--;)if(p[s]===u)continue t;e&&p.push(u),f.push(d)}else a(p,u,r)||(p!==f&&p.push(u),f.push(d))}return f}var _i=wt&&1/De(new wt([,-0]))[1]==Mo?function(t){return new wt(t)}:Si;function it(t,e){var r=t.__data__;return mi(e)?r[typeof e=="string"?"string":"hash"]:r.map}function Ct(t,e){var r=Uo(t,e);return di(r)?r:void 0}function mi(t){var e=typeof t;return e=="string"||e=="number"||e=="symbol"||e=="boolean"?t!=="__proto__":t===null}function Oi(t){return!!Ke&&Ke in t}function ji(t){if(t!=null){try{return He.call(t)}catch(e){}try{return t+""}catch(e){}}return""}function vi(t){return t&&t.length?bi(t):[]}function xi(t,e){return t===e||t!==t&&e!==e}function Ai(t){var e=Ge(t)?Yo.call(t):"";return e==$o||e==Po}function Ge(t){var e=typeof t;return!!t&&(e=="object"||e=="function")}function Si(){}Be.exports=vi});var It=I((ua,We)=>{var wi="[object Object]";function ki(t){var e=!1;if(t!=null&&typeof t.toString!="function")try{e=!!(t+"")}catch(r){}return e}function Ti(t,e){return function(r){return t(e(r))}}var Ei=Function.prototype,Ve=Object.prototype,Ue=Ei.toString,Ci=Ve.hasOwnProperty,Ii=Ue.call(Object),Mi=Ve.toString,$i=Ti(Object.getPrototypeOf,Object);function Pi(t){return!!t&&typeof t=="object"}function Fi(t){if(!Pi(t)||Mi.call(t)!=wi||ki(t))return!1;var e=$i(t);if(e===null)return!0;var r=Ci.call(e,"constructor")&&e.constructor;return typeof r=="function"&&r instanceof r&&Ue.call(r)==Ii}We.exports=Fi});var ze=I((V,D)=>{var Ni="[object Date]",Ki=typeof global=="object"&&global&&global.Object===Object&&global,Ze=typeof V=="object"&&V&&!V.nodeType&&V,Je=Ze&&typeof D=="object"&&D&&!D.nodeType&&D,Di=Je&&Je.exports===Ze,qe=Di&&Ki.process,Ye=function(){try{return qe&&qe.binding("util")}catch(t){}}(),Xe=Ye&&Ye.isDate;function Ri(t){return function(e){return t(e)}}var Hi=Object.prototype,Gi=Hi.toString;function Bi(t){return Vi(t)&&Gi.call(t)==Ni}var Li=Xe?Ri(Xe):Bi;function Vi(t){return!!t&&typeof t=="object"}D.exports=Li});var tr=I((pa,Qe)=>{var Ui=typeof global=="object"&&global&&global.Object===Object&&global,Wi=typeof self=="object"&&self&&self.Object===Object&&self,Ji=Ui||Wi||Function("return this")(),qi=Ji.isFinite;function Yi(t){return typeof t=="number"&&qi(t)}Qe.exports=Yi});var aa={};dr(aa,{defaults:()=>cr,generateAst:()=>ia,version:()=>na});var c=w(Ce(),1),or=w(Ne(),1),ir=w(Le(),1),O=w(It(),1),U=w(ze(),1),Kt=w(tr(),1);var er=w(It(),1);function m(t){return t==null?!1:Array.isArray(t)||typeof t=="string"?!!t.length:(0,er.default)(t)?!!Object.keys(t).length:typeof t=="number"}function Mt(t){if(typeof t!="string")throw new TypeError("Expected a string");return t.replace(/[|\\{}()[\]^$+*?.]/g,"\\$&").replace(/-/g,"\\x2d")}var $t=new Map,rr=(t,e)=>{if(!Array.isArray(t))switch(typeof t){case"string":t=[t];break;case"undefined":t=[];break;default:throw new TypeError(`Expected '${e}' to be a string or an array, but got a type of '${typeof t}'`)}return t.filter(r=>{if(typeof r!="string"){if(typeof r>"u")return!1;throw new TypeError(`Expected '${e}' to be an array of strings, but found a type of '${typeof r}' in the array`)}return!0})},Xi=(t,e)=>{e=_({caseSensitive:!1},e);let r=t+JSON.stringify(e);if($t.has(r))return $t.get(r);let n=t[0]==="!";n&&(t=t.slice(1)),t=Mt(t).replace(/\\\*/g,"[\\s\\S]*");let a=new RegExp(`^${t}$`,e.caseSensitive?"":"i");return a.negated=n,$t.set(r,a),a},Zi=(t,e,r,n)=>{if(t=rr(t,"inputs"),e=rr(e,"patterns"),e.length===0)return[];e=e.map(i=>Xi(i,r));let{allPatterns:a}=r||{},o=[];for(let i of t){let f,p=[...e].fill(!1);for(let[g,d]of e.entries())if(d.test(i)&&(p[g]=!0,f=!d.negated,!f))break;if(!(f===!1||f===void 0&&e.some(g=>!g.negated)||a&&p.some((g,d)=>!g&&!e[d].negated))&&(o.push(i),n))break}return o};function at(t,e,r){return Zi(t,e,r,!0).length>0}var zi={arrayVsArrayAllMustBeFound:"any",caseSensitive:!0};function Pt(t,e,r){if(!t.length||!e.length)return!1;let n=_(_({},zi),r),a=typeof t=="string"?[t]:Array.from(t);return typeof e=="string"?a.some(o=>at(o,e,{caseSensitive:n.caseSensitive})):n.arrayVsArrayAllMustBeFound==="any"?e.some(o=>a.some(i=>at(i,o,{caseSensitive:n.caseSensitive}))):e.every(o=>a.some(i=>at(i,o,{caseSensitive:n.caseSensitive})))}function Ft(t){return typeof t=="string"}function Qi(t){return typeof t=="number"}function Nt(t){return typeof t=="boolean"}var A=Array.isArray;function nr(t){return!!t&&t.some(e=>typeof e=="string")}function ta(t,e){return Object.keys(t).length===0||Object.keys(e).length===0||Object.keys(t).every(r=>Object.keys(e).includes(r))||Object.keys(e).every(r=>Object.keys(t).includes(r))}function b(t){return t===null?"null":(0,U.default)(t)?"date":(0,O.default)(t)?"object":A(t)?"array":typeof t}var ea={cb:null,mergeObjectsOnlyWhenKeysetMatches:!0,ignoreKeys:[],hardMergeKeys:[],hardArrayConcatKeys:[],mergeArraysContainingStringsToBeEmpty:!1,oneToManyArrayObjectMerge:!1,hardMergeEverything:!1,hardArrayConcat:!1,ignoreEverything:!1,concatInsteadOfMerging:!0,dedupeStringsInArrayValues:!1,mergeBoolsUsingOrNotAnd:!0,useNullAsExplicitFalse:!1};function S(t,e,r,n){var d;let a;if(n.useNullAsExplicitFalse&&(e===null||r===null))return typeof n.cb=="function"?n.cb(e,r,null,{path:t.path,key:t.key,type:t.type}):null;let o=A(e)||(0,O.default)(e)?(0,c.default)(e):e,i=A(r)||(0,O.default)(r)?(0,c.default)(r):r,f;n.ignoreEverything?f=o:n.hardMergeEverything&&(f=i);let p=n.hardMergeEverything||n.ignoreEverything;if(A(o))if(m(o))if(A(i)&&m(i)){if(n.mergeArraysContainingStringsToBeEmpty&&(nr(o)||nr(i))){let s=p?f:[];return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:a,key:t.key,type:t.type}):s}if(n.hardArrayConcat){let s=p?f:o.concat(i);return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:a,key:t.key,type:t.type}):s}let u=[];for(let s=0,h=Math.max(o.length,i.length);s<h;s++)a=(d=t.path)!=null&&d.length?`${t.path}.${s}`:`${s}`,(0,O.default)(o[s])&&(0,O.default)(i[s])&&(n.mergeObjectsOnlyWhenKeysetMatches&&ta(o[s],i[s])||!n.mergeObjectsOnlyWhenKeysetMatches)?u.push(S({path:a,key:t.key,type:[b(o),b(i)]},o[s],i[s],n)):n.oneToManyArrayObjectMerge&&(o.length===1||i.length===1)?u.push(o.length===1?S({path:a,key:t.key,type:[b(o),b(i)]},o[0],i[s],n):S({path:a,key:t.key,type:[b(o),b(i)]},o[s],i[0],n)):n.concatInsteadOfMerging?(s<o.length&&u.push(o[s]),s<i.length&&u.push(i[s])):(s<o.length&&u.push(o[s]),s<i.length&&!(0,or.default)(o,i[s])&&u.push(i[s]));n.dedupeStringsInArrayValues&&u.every(s=>Ft(s))&&(u=(0,ir.default)(u).sort()),o=(0,c.default)(u)}else{let u=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),u,{path:a,key:t.key,type:t.type}):u}else{if(m(i)){let s=p?f:i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:a,key:t.key,type:t.type}):s}let u=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),u,{path:a,key:t.key,type:t.type}):u}else if((0,O.default)(o)){if(m(o)){if(A(i)){if(m(i)){let y=p?f:i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),y,{path:a,key:t.key,type:t.type}):y}let h=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),h,{path:a,key:t.key,type:t.type}):h}if((0,O.default)(i)){Object.keys(i).forEach(y=>{var Dt;a=(Dt=t.path)!=null&&Dt.length?`${t.path}.${y}`:`${y}`,o.hasOwnProperty(y)?Pt(y,n.ignoreKeys)?o[y]=S({path:a,key:y,type:[b(o),b(i)]},o[y],i[y],W(_({},n),{ignoreEverything:!0})):Pt(y,n.hardMergeKeys)?o[y]=S({path:a,key:y,type:[b(o),b(i)]},o[y],i[y],W(_({},n),{hardMergeEverything:!0})):Pt(y,n.hardArrayConcatKeys)?o[y]=S({path:a,key:y,type:[b(o),b(i)]},o[y],i[y],W(_({},n),{hardArrayConcat:!0})):o[y]=S({path:a,key:y,type:[b(o[y]),b(i[y])]},o[y],i[y],n):o[y]=i[y]});let h=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),h,{path:t.path,key:t.key,type:t.type}):o}let s=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}if(A(i)||(0,O.default)(i)||m(i)){let s=p?f:i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}let u=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),u,{path:t.path,key:t.key,type:t.type}):u}else if((0,U.default)(o)){if((0,Kt.default)(+o)){if((0,U.default)(i)){if((0,Kt.default)(+i)){let y=p?f:o>i?o:i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),y,{path:t.path,key:t.key,type:t.type}):y}let h=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),h,{path:t.path,key:t.key,type:t.type}):h}let s=p?f:i||o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}if((0,U.default)(i)){let s=p?f:i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}let u=p?f:i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),u,{path:t.path,key:t.key,type:t.type}):u}else if(Ft(o)){if(m(o)){if((A(i)||(0,O.default)(i)||Ft(i))&&m(i)){let h=p?f:i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),h,{path:t.path,key:t.key,type:t.type}):h}let s=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}if(i!=null&&!Nt(i)){let s=p?f:i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}let u=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),u,{path:t.path,key:t.key,type:t.type}):u}else if(Qi(o)){if(m(i)){let s=p?f:i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}let u=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),u,{path:t.path,key:t.key,type:t.type}):u}else if(Nt(o)){if(Nt(i)){if(n.mergeBoolsUsingOrNotAnd){let h=p?f:o||i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),h,{path:t.path,key:t.key,type:t.type}):h}let s=p?f:o&&i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}if(i!=null){let s=p?f:i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}let u=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),u,{path:t.path,key:t.key,type:t.type}):u}else if(o===null){if(i!=null){let s=p?f:i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),s,{path:t.path,key:t.key,type:t.type}):s}let u=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),u,{path:t.path,key:t.key,type:t.type}):u}else{let u=p?f:i;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),u,{path:t.path,key:t.key,type:t.type}):u}let g=p?f:o;return typeof n.cb=="function"?n.cb((0,c.default)(e),(0,c.default)(r),g,{path:t.path,key:t.key,type:t.type}):g}function ar(t,e,r){var a,o;if(!arguments.length)throw new TypeError("object-merge-advanced/mergeAdvanced(): [THROW_ID_01] Both inputs are missing");let n=_(_({},ea),r);return typeof n.ignoreKeys=="string"&&(n.ignoreKeys=[n.ignoreKeys]),typeof n.hardMergeKeys=="string"&&(n.hardMergeKeys=[n.hardMergeKeys]),(a=n==null?void 0:n.hardMergeKeys)!=null&&a.includes("*")&&(n.hardMergeEverything=!0),(o=n==null?void 0:n.ignoreKeys)!=null&&o.includes("*")&&(n.ignoreEverything=!0),S({key:null,path:"",type:[b(t),b(e)]},t,e,n)}var sr="4.0.0";var na=sr,cr={dedupe:!0};function oa(t){return Object.keys(t).sort().reduce((e,r)=>(e[r]=t[r],e),{})}function ia(t,e){if(Array.isArray(t)){if(t.length===0)return{}}else throw new Error(`array-of-arrays-into-ast: [THROW_ID_01] inputArr must be array. Currently it's of a type ${typeof t} equal to:
${JSON.stringify(t,null,4)}`);let r=_(_({},cr),e),n={};return t.forEach(a=>{let o=null;for(let i=a.length;i--;)o={[a[i]]:[o]};n=ar(n,o,{concatInsteadOfMerging:!r.dedupe})}),oa(n)}return br(aa);})();
/**
 * @name object-merge-advanced
 * @fileoverview Deeply merge JSON-like data structures
 * @version 14.0.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/object-merge-advanced/}
 */
/**
 * @name util-nonempty
 * @fileoverview Is the input (plain object, array, string or whatever) not empty?
 * @version 5.0.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/util-nonempty/}
 */
